#!/bin/sh

. ./fsx.conf
echo "############## packaging freyasx-$SXVER ################"
echo SXVER=$SXVER
echo DGVER=$DGVER
echo "/////////////////////////////////////////////////////////"

(
	cd freyasx-$SXVER
	make -s dtar
	ls -l tmp.tar
)
if [ ! -d freyasx ]; then
	mkdir freyasx
	mkdir freyasx/FSXHOME
	mkdir freyasx/DGROOT
fi
cd freyasx
cp -p ../fsx.conf  .
cp -p ../freyasx-$SXVER/INSTALL.sh .

if [ -d freyasx-$SXVER ]; then
	rm -r freyasx-$SXVER
fi
cp -p ../down/delegate$DGVER.tar.gz .

if [ -d freyasx-$SXVER ]; then
	rm -r freyasx-$SXVER
fi
ls -l ../freyasx-$SXVER/freyasx-$SXVER.tar.gz
if [ -f ../freyasx-$SXVER/freyasx-$SXVER.tar.gz ]; then
	tar xfz ../freyasx-$SXVER/freyasx-$SXVER.tar.gz
fi
if [ -d freyasx-$SXVER ]; then
(
	cd freyasx-$SXVER
	mkdir distscripts
	cp -p ../../fsx.make distscripts/fsx.make

	CGIFILES=`/bin/bash -c "echo \
		../../cgi-bin/*.{html,url,cnv,lst} \
		../../cgi-bin/{*1,inc,dec,up,down,score*,freyasx*}.gif \
		../../cgi-bin/{in,out,prev*,next*,tops,ends}.gif \
		"`

	echo CGIFILES=$CGIFILES
	cp -p $CGIFILES cgi-bin
)
fi
tar cf freyasx-$SXVER.tar freyasx-$SXVER
gzip -f freyasx-$SXVER.tar
rm -r freyasx-$SXVER

cd ..
tar cf freyasx-$SXVER.tar \
	freyasx/delegate$DGVER.tar.gz \
	freyasx/freyasx-$SXVER.tar.gz \
	freyasx/DGROOT \
	freyasx/FSXHOME \
	freyasx/INSTALL.sh \
	freyasx/fsx.conf

gzip -f freyasx-$SXVER.tar
ls -l freyasx-$SXVER.tar.gz

#### upload ####
cp -p freyasx-$SXVER.tar.gz down/freyasx-$SXVER.tar.gz
ls -l down/freyasx-$SXVER.tar.gz
exit 0
