// Copyright (c) 1997 HARADA Masanori. All rights reserved.
//
// $Id: Description.cc,v 0.10 1998-01-08 01:45:36+09 harada Exp harada $
//
// this class corresponds to a record in .dsc file

#ifndef DESCFILE_H_INCLUDED
#define DESCFILE_H_INCLUDED

#include "SX.h"
#include "DescRecord.h"

class DescFile {
protected:
    Fstream &file;
    const int blksize;
    int *mem;
    int siz;
public:
    DescFile(Fstream &f, int bs = DSCBLOCKSIZE) : file(f), blksize(bs) {
        siz = f.size() / blksize;
    }
    virtual ~DescFile() {
        if(file.is_open()) file.close();
    }
    int getsize() const { return siz; }
    void setmmap(int *m, int s){ mem = m; siz = s; }
    int *getmmap(){ return mem; }
    int GetLastModified(int nth);
    char *GetUrl(int nth);
    char *GetAuthor(int nth);
    int getInts(int nth, int &size, int &date, int &lmod);
    operator bool() const { return file.is_open(); }
    int getRecord(DescRecord &record, int nth);
};

int *makesortUrl(Fstream &descf, int &len);
int makesumfiles(Fstream &descf, Fstream &sumf);
int findUrl(NumFile &nums, const char *url);

#endif
