// Copyright (c) 1997 HARADA Masanori. All rights reserved.
//
// $Id: Description.cc,v 0.10 1998-01-08 01:45:36+09 harada Exp harada $
//
#ifndef DESCRECORD_H_INCLUDED
#define DESCRECORD_H_INCLUDED

#include "SX.h"

class DescRecord {
    friend ostream& operator <<(ostream &stream, DescRecord &that);
protected:
    const size_t blksize;
    size_t size;
    time_t date;
    time_t lastmodified;
    int crc32;
    char *url;
    char *author;
    char *title;
    char *digest;
    char *mystrdup(const char *str);
public:
    DescRecord(size_t blocksz = DSCBLOCKSIZE);
    DescRecord(const char *buf, size_t blocksz = DSCBLOCKSIZE);
    virtual ~DescRecord();
    void init(const char *buf);
    void reset();
    DescRecord &operator =(const DescRecord &that);
    time_t getDate() const { return date; }
    time_t getLastModified() const { return lastmodified; }
    size_t getSize() const { return size; }
    int getCRC32() const { return crc32; }
    const char *getUrl() const { return url; }
    const char *getAuthor() const { return author; }
    const char *getTitle() const { return title; }
    const char *getDigest() const { return digest; }
};

#endif

inline char *
DescRecord::mystrdup(const char *str){
    int len = strlen(str);
    char *p = new char[len + 1];
    strcpy(p, str);
    return p;
}
