// Copyright (c) 1997 HARADA Masanori. All rights reserved.
//
// $Id: HeapBag.h,v 0.9 1997-12-27 07:16:49+09 harada Exp $
//

// TODO: p  const ĤϤ

// ͤΤ˥ݥ󥿤ĥҡ
// HashBagȤϰۤʤꡢݥ󥿤λؤΤ delete ϹԤʤʤ

#ifndef HEAPBAG_H_INCLUDED
#define HEAPBAG_H_INCLUDED

#include "SX.h"

template <class T>
class HeapBag {
private:
    int size;
    int N;
    T **p;

    int upheap(int k);
    void downheap(int k);
    T *removetop();
    T *replacetop(T *vp);
public:
    HeapBag();
    HeapBag(int capacity);
    HeapBag(const HeapBag<T> &that);
    ~HeapBag();
    void insert(T *xp);
    HeapBag & operator +=(T *xp){ insert(xp); return *this; }
    HeapBag & operator =(const HeapBag<T> &that);
    operator bool() const { return N > 0; }
    int sort(T **dst);
    void printDebug(ostream &out = cout) const;
};

template <class T>
HeapBag<T>::HeapBag()
    : size(0), N(0), p(NULL)
{
}

template <class T>
HeapBag<T>::HeapBag(int capacity)
    : N(0)
{
    size = capacity + 1;
/*
    p = new (T *)[size];
*/
    p = new T*[size];
    memset(p, 0, sizeof(T *) * size);
}

template <class T>
HeapBag<T>::HeapBag(const HeapBag<T> &that)
    : size(that.size), N(that.N)
{
/*
    p = new (T *)[size];
*/
    p = new T*[size];
    memcpy(p, that.p, sizeof(T *) * size);
}

template <class T>
HeapBag<T>::~HeapBag(){
    delete []p;                 // ݥ󥿤λؤΤϺʤ
}

template <class T> HeapBag<T> &
HeapBag<T>::operator =(const HeapBag<T> &that){
    delete []p;
    N = that.N;
    size = that.size;
/*
    p = new (T *)[size];
*/
    p = new T*[size];
    memcpy(p, that.p, sizeof(T *) * size);
    return *this;
}

template <class T> void
HeapBag<T>::printDebug(ostream &out) const{
    out << "-- Heap --" << endl;
    out << "  size = " << size << ", N = " << N << endl;
    out << "p[] = ( ";
    for(int i = 1; i < N; i++)
        out << *p[i] << ' ';
    out << ')' << endl;
}

template <class T> void
HeapBag<T>::insert(T *vp){
    assert(N + 1 < size);
    p[++N] = vp;                // p[0]ϻȤʤ
    (void)upheap(N);
}

template <class T> int
HeapBag<T>::upheap(int k){
    T *vp;
    vp = p[k];
    while(k / 2 != 0 && *p[k / 2] <= *vp){
        p[k] = p[k / 2]; k = k / 2;
    }
    p[k] = vp;
    return k;
}

template <class T> void
HeapBag<T>::downheap(int k){
    int j;
    T *vp;
    vp = p[k];
    while(k <= N / 2){
        j = k * 2;
        if (j < N && *p[j] < *p[j + 1]) j++;
        if (*vp >= *p[j]) break;
        p[k] = p[j]; k = j;
    }
    p[k] = vp;
}

template <class T> T *
HeapBag<T>::removetop(){
    T *vp = p[1];
    p[1] = p[N--];
    downheap(1);
    return vp;
}

template <class T> T *
HeapBag<T>::replacetop(T *vp){
    p[0] = vp;
    downheap(0);
    return p[0];
}

// sortԤʤHeapƤϼ
template <class T>int
HeapBag<T>::sort(T **dst){
    int i;
    for(i = N; i >= 1; i--) dst[i - 1] = removetop();
    return N;
}

#endif
