// Copyright (c) 1997 HARADA Masanori. All rights reserved.
//
// $Id: IndexFile.cc,v 0.10 1998-05-06 01:43:44+09 harada Exp $
// $Id: IndexFile.cc,v 0.98 2004-08-01 y.sato Exp $
//   Data Representation in the Index File of FreyaSX
//     [0..N] the number of elements of the following packed list of pos_t
//     [N+1..] a packed list of pos_t
//

#include "SX.h"
#include "IndexFile.h"


IndexFile::IndexFile(const char *filename, const char *mode){
    idxf = Fopen(filename,mode);
    if(idxf == NULL)
        error = 1;
    else{
        error = 0;
    }
}
IndexFile::~IndexFile(){
    if(idxf != NULL ){
        fclose(idxf);
        idxf = NULL;
    }
}
int
IndexFile::store(const pos_t *list, int listLen, wordid_t &wid){
/*
    size_t off = ftell(idxf);
*/
    off_t off = Ftell(idxf);
    fputintvls(idxf,list,listLen);
    wid = off;
    return 0;
}

pos_t *
IndexFile::fetch(wordid_t wid, int &listLen, ShiftMask *mask){
/*
    size_t off = wid;
    if( fseek(idxf, off, 0) != 0 ){
*/
    off_t off = wid;
    if( Fseek(idxf, off, 0) != 0 ){
        if(feof(idxf)){
            clearerr(idxf);
/*
            if( fseek(idxf, off, 0) == 0 ){
*/
            if( Fseek(idxf, off, 0) == 0 ){
            }
        }
    }
    pos_t *list = fgetintvls(idxf,&listLen);
    if(mask != NULL){
        listLen = maskList(list,listLen,mask);
    }
    return list;
}
