// Copyright (c) 1997 HARADA Masanori. All rights reserved.
//
// $Id: Indexer.h,v 0.10 1998-02-09 22:45:05+09 harada Exp $
//
#ifndef INDEXER_H_INCLUDED
#define INDEXER_H_INCLUDED

#include "SX.h"
#include "WordBreaker.h"
#include "HashBag.h"
#include "Unifier.h"
#include "IndexFile.h"
#include "LexiconFile.h"

class Indexer {
private:
    WordBreaker &breaker;
    const Unifier &unifier;
    bool noUnif;

    int buildindex(LexiconFile &lexfile, IndexFile &idxfile,
                   HashBag<valueSet<pos_t> > &hashbuf);
    static void makefilename(char *lexfilename, char *idxfilename,
                             const char *basename, int nth);
    void addMETA(const char *key, HashBag<valueSet<pos_t> > &bag, ElemCtx &ectx, pos_t offset);
    void output_mapentry(Fstream &xmapfile, ElemCtx &ectx, int size, int nwords);
    void deentitize(char *dst, const char *src);

public:
    int NewDocs;
    ConText *Ctx;
    int SeedDocs;
    int SeedWords;
    Fstream *idescf; // for compatibility with old FDIF+DSC interface
    Fstream *descf;
    char Url[256];
    char Docpath[256];
    char Author[256];
    char Title[256];
    char Digest[256];
    int Fsize;
    int Fdate;
    int Mtime;
    int Crc32;
/*
    Indexer(WordBreaker &wb, const Unifier &unif);
*/
    Indexer(WordBreaker &wb, const Unifier &unif, ConText *ctx);
    Indexer(ConText *ctx);
    virtual ~Indexer();
/*
    int processText(istream &source, LexiconFile &lexfile, IndexFile &idxfile,
*/
    int processText(istream &source, off_t &ccount,
                    LexiconFile &lexfile, IndexFile &idxfile,
                    Fstream &xmapfile, pos_t &offset);
    int makeIndices(istream &source, const char *basename,
                   Fstream &xmapfile, pos_t &offset);

    int mergeIndices(const char *newbase,
                            const char *tmpbase, int tmpNum,
                            IMask *mask, const char *seedbase, Files &files);
/*
                            const char *tmpbase, int tmpNum);
*/
    int mergeFiles(LexiconFile *newlexicon, IndexFile *newindex,
                          int n, LexiconFile *lexicons[],
/*
                          IndexFile *indices[], int mask[],
*/
                          IndexFile *indices[], Files &files, IMask *mask,
                          pos_t *shifttbl = NULL);

    virtual void printDebug(ostream &out = cout) const;
    void offUnifier(){ noUnif = 1; }
    int noUnifier(){ return noUnif; }
    IMask *toberemoved(const char *base, int ndocs);
};

void createSortFiles(const char *base, Files &files);

#endif
