//
// $Id: Label.h,v 0.9 1998-01-10 01:44:01+09 harada Exp harada $
//
#ifndef LABEL_H_INCLUDED
#define LABEL_H_INCLUDED

#ifdef SUNOS4
extern "C" caddr_t mmap(caddr_t addr, size_t len, int prot,
                        int flags, int fd, off_t off);
extern "C" int munmap(caddr_t addr, int len);
#endif

typedef unsigned short int labelid_t;

class Label {
    struct label_info {
        int id;
        int usedNum;
        const char *name;
        int count;
        double score;
    };
protected:
    const int lbl_fd;
    const int lbi_fd;
    size_t lbl_filesize;
    size_t lbi_filesize;
    caddr_t mapaddr;
    caddr_t infoaddr;
    int recordNum;
    struct label_info *labelInfo;
    void resetInfo();
    int countLabels(struct label_info infotbl[],
                    const Result *results, int resultsNum);
    int countLabels2(struct label_info infotbl[],
                     const Result *results, int resultsNum);
public:
    enum { MAXLABELS = 32, MAXDISPLAYLABELS = 200 };
    Label(int fildsc, int infofildsc);
    virtual ~Label();
    int recommend1(const Result *results, int resultsNum);
    int recommend2(const Result *results, int resultsNum);
    int recommend3(const Result *results, int resultsNum);
    int recommend4(const Result *results, int resultsNum);
    int recommend5(const Result *results, int resultsNum);
    int recommend6(const Result *results, int resultsNum);
    const labelid_t *getLabels(urlid_t docid){
        return ((labelid_t *)mapaddr) + docid * 16;
    }
};

#endif
