// Copyright (c) 1997 HARADA Masanori. All rights reserved.
//
// $Id: LexiconEntry.h,v 0.9 1997-12-27 07:19:35+09 harada Exp $
//
#ifndef LEXICONENTRY_H_INCLUDED
#define LEXICONENTRY_H_INCLUDED

#include "IndexFile.h"

typedef unsigned int Lexoff_t; /* offset in the LexiconFile */
#define ILL_WID ((wordid_t)-1)

class LexiconEntry {
/*
    friend ostream& operator<<(ostream &stream, const LexiconEntry &entry);
    friend istream& operator>>(istream &stream, LexiconEntry &entry);
*/
    friend Fstream& operator<<(Fstream &stream, const LexiconEntry &entry);
    friend Fstream& operator>>(Fstream &stream, LexiconEntry &entry);
private:
    int valueNum;
    int listSize; // reference count
    pos_t values[MAXLEXLOCALINDEX];
    wordid_t wid; // the pointer into .idx file
    char key[MAXKEYLENGTH+1];
    bool _eof;
public:
    Lexoff_t lid; // offset in LexiconFile
    int eof(){ return _eof; }
    LexiconEntry(const char *keystr);
    LexiconEntry &store(IndexFile &indexfile, const pos_t *list, int ListLen);
/*
    pos_t *fetch(IndexFile &indexfile, int &listLen) const;
*/
    pos_t *fetch(IndexFile &indexfile, int &listLen, ShiftMask *mask=NULL) const;

    /*
    void LexiconEntry::printDebug(ostream &out) const;
    */
    void printDebug(ostream &out) const;

    LexiconEntry();
    virtual ~LexiconEntry();
    const char *getkey() const { return key; }
    const int getrefcount() const { return listSize; }
};

#endif
