// Copyright (c) 1997 HARADA Masanori. All rights reserved.
//
// $Id: LexiconFile.h,v 0.9 1997-12-27 07:20:20+09 harada Exp $
//

// TODO: ǥˤĤƲͤƤʤ

#ifndef LEXICONFILE_H_INCLUDED
#define LEXICONFILE_H_INCLUDED

#include "LexiconEntry.h"

typedef struct {
    char magic[16];
    int  nentry;
/*
    int  fileSize;
    int  endofLexicons;
    int  keymapoff; // displacement to the LexiconId table
*/
    Lexoff_t fileSize;
    Lexoff_t endofLexicons;
    Lexoff_t keymapoff; // displacement to the LexiconId table
    char padd[256];
} LexHead;

class LexiconFile {
    // friend class LexiconManager
private:
    enum { HEADERSIZE = 256, MAXPREFIXMATCH = 32 };
    static char MAGIC[];
    Fstream &file;
    char *name;
    LexHead Head;
/*
    int *kindex;
*/
    Lexoff_t *kindex;
    Lexoff_t *offsetTbl;
    const int readonly;
/*
    size_t *offsetTbl;
*/
    const char *err;

/*
    int findRegion(const char *key, size_t &from, size_t &to);
*/
    int findRegion(const char *key, Lexoff_t &from, Lexoff_t &to);
    int indexhash(const char *key);
    int writeHeader();
    int readHeader();
public:
    // enum { EXACTMATCH = 0, PREFIXMATCH = 1, FINDPREFIXES = 2 };
    LexiconFile(const char *lexpath, const char *mode);
    virtual ~LexiconFile();
    const char *error() const { return err; }
/*
    int tellp(){ return Head.fileSize; }
*/
    off_t tellp(){ return Head.fileSize; }
    int nentry(){ return Head.nentry; }

    int search(const char *key, LexiconEntry &result);
    LexiconEntry **prefixsearch(const char *key, int &n);
    int findPrefix(const char *text, LexiconEntry &result);
/*
    istream &rewind();
*/
    Fstream &rewind();
    void prepareAppend();
    int appendEntry(const LexiconEntry &entry);
    void printDebug(ostream &out = cout) const;
    void appendKeymap(FILE *kfp, int size);
    int getlexstr(int lid, LexiconEntry &entry);
    /*
    int LexiconFile::lexid(const char *key);
    */
    int lexid(const char *key);
    void dump();
};

#endif
