// Copyright (c) 1997 HARADA Masanori. All rights reserved.
//
// $Id: Query.h,v 0.9 1997-12-27 07:21:31+09 harada Exp $
//
#ifndef QUERY_H_INCLUDED
#define QUERY_H_INCLUDED

#include "Result.h"
#include "Retriever.h"

// abstract lass
class Query {
protected:
    int type;
    int err;
    void lowerword(char *word);
    void printtype(ostream &out = cout);
public:
    enum error_type { SUCCESS = 0,
                      EMPTYQUERY, //
                      ASTERISKLOCATION, // * ϺǸˤȤޤ
                      END_OF_QUERY_ERROR
    };
    Query(int t) : type(t), err(0) { }
    virtual ~Query() { }
    virtual ostream& print(ostream &out = cout) = 0;
    virtual void printDebug(ostream &out = cout) = 0;
    virtual int error() const = 0;
    virtual Result *eval(Retriever &ret, int &resultLen)= 0;
};

class SimpleQuery : public Query {
protected:
    char *word;
    int isprefixsearch;
public:
    SimpleQuery(const char *str, int t = 0);
    virtual ~SimpleQuery();
    virtual ostream& print(ostream &out = cout);
    virtual void printDebug(ostream &out = cout);
    virtual int error() const { return err; }
    virtual Result *eval(Retriever &ret, int &resultLen);
};

class PhraseQuery : public Query {
protected:
    int wordNum;
    char *words[MAXWORDSINPHRASE];
    int offsets[MAXWORDSINPHRASE];
    int tokenize(const char *str);
public:
    PhraseQuery(const char *str, int t = 0);
    virtual ~PhraseQuery();
    virtual ostream& print(ostream &out = cout);
    virtual void printDebug(ostream &out = cout);
    virtual int error() const { return 0; }
    virtual Result *eval(Retriever &ret, int &resultLen);
};

#endif
