// Copyright (c) 1997 HARADA Masanori. All rights reserved.
//
// $Id: Retriever.h,v 0.9 1997-12-27 07:24:16+09 harada Exp harada $
//
#ifndef RETRIEVER_H_INCLUDED
#define RETRIEVER_H_INCLUDED

#include "LexiconFile.h"
#include "IndexFile.h"
#include "Result.h"
#include "XMap.h"
#include "ConText.h"

class Retriever {
protected:
    //    Retriever & operator = (const Retriever &that); // forbidden
    LexiconFile &lexiconfile;
    IndexFile &indexfile;
    const XMap &xmap;
    int wordoff; /* word offset */
    int attop; // at the top of a Kanji/Katakana/Hiragana word
    pos_t *searchWord(const char *key, int &resultLen);
    pos_t *prefixsearchWord(const char *key, int &resultLen);
    pos_t *searchJapaneseWord(const char *key, int &resultLen,
                              int isprefixsearch = 0);
    pos_t *searchJapaneseWordX(const char *key, int &resultLen,
                              int isprefixsearch = 0);
    Result *translateList(const pos_t *list, int listLen,
                          int &resultLen, int type);
    pos_t *searchPhrase(char **keys, int offsets[],
                        int nkeys, int &resultLen, int isprefixsearch = 0);
    pos_t *search(const char *text, int &resultLen, int isprefixsearch = 0);
public:
    int Idxid;
    ConText *Ctx;
    Retriever(LexiconFile &lex, IndexFile &idxfile, const XMap &map);
    virtual ~Retriever();
    virtual Result *retrievePhrase(char **keys, int *offsets,
                                   int nkeys, int &resultLen, int type);
    virtual Result *retrieve(const char *text, int &resultLen,
                             int type, int isprefixsearch = 0);
};

#endif
