// Copyright (c) 2004 Yutaka Sato. All rights reserved.

#ifndef SXC_H_INCLUDED
#define SXC_H_INCLUDED

#include "typedef.h"

#ifdef _MSC_VER
int isaTty(int fd);
#else
#define isaTty(fd) isatty(fd)
#endif

int strcasecmp(const char*, const char *);
int strncasecmp(const char*, const char *, size_t);
#ifdef _MSC_VER
#define snprintf _snprintf
#define sleep(s) _sleep(s*1000)
#endif

double Time();
int delSpaces(char *str);
char *Strncpy(char *s1, const char *s2, int n);
char *SX_defaultDict(char *path, int psiz);
int SX_createBase(char *name, char *path, int psiz);
int SX_searchBase(char *name, char *path, int psiz);
int SX_tempName(char *name);
int SX_realName(char *name);
int SX_arrayMap(char *path, int **addr);
void SX_scanCONF(const char *conf);
extern int opt_v;
extern int opt_S;
int ElemId(const char *cp, const char **np, const char *brk);
int ElemScore(int docid, int type);
const char *ElemQName(int id);
/*
void LapReport(int update, const char *fmt, int v1, int v2, int v3, int v4);
*/
void LapReport(int update, const char *fmt, ...);
double LapTime();
typedef int (*sortfunc)(const void*,const void*);
int mergeLists(pos_t *dst, int dsiz, pos_t **src, int *lens, int lsiz);
void checkList(const char *where, const pos_t *list, int len);

extern int MinBUFFERINGWORDS;
extern int MaxBUFFERINGWORDS;
extern int MaxKEYLENGTH;
extern int MinKEYLENGTH;
extern int MinCAPITALCOL;
extern int MaxLEXLOCALINDEX;
extern int IoBUFFERSIZE;

int fputintvl(FILE *fo, pos_t *val);
int fgetintvl(FILE *fi, pos_t *val);
int fputintvls(FILE *fo, const pos_t *list, int listLen);
pos_t *fgetintvls(FILE *fi, int *listLen);
FILE *Fopen(const char *path, const char *mode);
int Feof(FILE *fp);
int Fread(FILE *fp, char *buf, int siz);
int Fwrite(FILE *fp, char *buf, int siz);
int Ftruncate(FILE *fp);
/*
int Fsize(FILE *fp);
*/
off_t Fsize(FILE *fp);
off_t Ftell(FILE *fp);
off_t Fseek(FILE *fp,off_t off,int whence);
off_t FileSize(const char *path);

enum element_type {
    TYPE_META = 0,
    TYPE_URL = 1,
    TYPE_TEXTW3 = 2,
    TYPE_TEXTW2 = 3,
    TYPE_TEXTW1 = 4,
    TYPE_DIGEST = 5,
    TYPE_TITLE = 6,
    TYPE_AUTHOR = 7,
    TYPE_LINK = 8,
};
#define TYPE_ANY 0x3F // not a real text type, used in query only

#endif // SX_H_INCLUDED
