// Copyright (c) 1997 HARADA Masanori. All rights reserved.
//
// $Id: Word.cc,v 0.9 1997-12-27 07:25:26+09 harada Exp $
//
#include "SX.h"
#include "Word.h"
#include "jlib.h"

// strcmp()ŪӴؿ
int
Word::cmp(const Word &that) const{
    if(buf == NULL){
        if(that.buf == NULL) return 0;
        return -1;
    }
    if(that.buf == NULL) return 1;
    return jstrcmp(buf, that.buf);
}

unsigned long elfhash(const unsigned char *name) {
  unsigned long h = 0, g;
  while (*name) {
      h = (h << 4) + *name++;
      g = h & 0xF0000000L;
      if (g) h ^= g >> 24;
      h &= ~g;
  }
  return h;
}

extern int HashLevel;
unsigned int
Word::hashCode() const{
  switch( HashLevel ){
  case 0:
    return elfhash((unsigned char *)buf);
/*
if the size hash is larger than 24 bits (about 1M) ...
    return elfhash((unsigned char *)buf) * 4;
  case 1:
    return elfhash((unsigned char *)buf) << 8 | strCRC8(0,buf);
*/
  default:
    return strCRC32(0,buf);
  }
/*
    unsigned int v = 0;
    for(const char *p = buf; *p; p++){
        v = (v << 8) + *p;
    }
    return v;
*/
}

const Word &
Word::operator =(const Word &that){
/*
    if(buf == NULL || ( strlen(buf) < strlen(that.buf) )){
*/
    if(buf == NULL || strlonger(that.buf,buf)){
        if(0 <= leng)
        if(buf) delete []buf;
/*
        buf = new char[strlen(that.buf) + 1];
*/
	if( stringBank ){
		int len = strlen(that.buf);
		buf = stringBank->newstring(that.buf);
		leng = -(len+1);
		return *this;
	}else{
        leng = strlen(that.buf) + 1;
        buf = new char[leng];
	}
    }
    strcpy(buf, that.buf);
    return *this;
}

int
Word::paste(char *to) const {
    if(NULL == buf) return 0;
    const char *bufp = buf;
    while((*to++ = *bufp++))
        ;
    return bufp - buf;
}


ostream&
operator<<(ostream &stream, Word &w){
    return stream << w.buf;
}

bool
operator ==(const Word &foo, const Word &bar){
    return 0 == foo.cmp(bar);
}
bool
operator !=(const Word &foo, const Word &bar){
    return 0 != foo.cmp(bar);
}

bool
operator >=(const Word &foo, const Word &bar){
    return foo.cmp(bar) >= 0;
}
bool
operator <=(const Word &foo, const Word &bar){
    return foo.cmp(bar) <= 0;
}
bool
operator >(const Word &foo, const Word &bar){
    return foo.cmp(bar) > 0;
}
bool
operator <(const Word &foo, const Word &bar){
    return foo.cmp(bar) < 0;
}

#ifdef WORD_DEBUG
// % g++ -Wall -g -O -DWORD_DEBUG Word.cc jlib.o
int main(){
    Word s = "harada";
    Word t = "";

    if(s == t)
        cout << s << " is equal to " << t << endl;
    else if(s > t)
        cout << s << " is bigger than " << t << endl;
    else
        cout << s << " is smaller than " << t << endl;

    return 0;
}
#endif
