// Copyright (c) 1997 HARADA Masanori. All rights reserved.
//
// miscellaneous (especially system dependent) definitions
// $Id: config.h,v 0.16 1998-06-22 00:49:49+09 harada Exp $
//
#ifndef CONFIG_H_INCLUDED
#define CONFIG_H_INCLUDED

#ifndef __USE_FIXED_PROTOTYPES__
#define __USE_FIXED_PROTOTYPES__
#endif

/*
#define FREYABANNER "Freya version 0.92.3 (1998/Jun/22)"
*/
/*
#define FREYABANNER "FreyaSX version 0.99.16 (2006/Jul/18)"
*/
#define FREYABANNER "FreyaSX version 0.99.18 (2014/August/18)"
#ifndef DEFAULT_MORPHDIC_PATH
#define DEFAULT_MORPHDIC_PATH "/usr/local/lib/freya/dict/icot.dic"
#endif

#ifndef PATH_MAX
#ifdef MAXPATHLEN
#define PATH_MAX MAXPATHLEN
#else
#define PATH_MAX 255
#endif // MAXPATHLEN
#endif // PATH_MAX

#ifndef LINE_MAX
#define LINE_MAX 2048
#endif // LINE_MAX

#ifndef NAME_MAX
#define NAME_MAX 255
#endif // NAME_MAX

#ifdef SUNOS4
extern const char * const sys_errlist[];
inline const char *
mystrerror(int errnum){ return sys_errlist[errnum]; }
extern "C" int strcasecmp(char *s1, char *s2);
extern "C" int strncasecmp(char *s1, char *s2, int count);
extern "C" int flock(int, int);
#else  // SUNOS4
inline const char *
mystrerror(int errnum){ return strerror(errnum); }
#endif // SUNOS4

#define PRINTERR() \
cerr << __FILE__ << '(' << __LINE__ << ") " << mystrerror(errno) << endl;

#define PRINTERRMSG(msg) \
cerr << __FILE__ << '(' << __LINE__ << ") " \
<< mystrerror(errno) << ": " << msg << endl;

//
// parameters
//
enum freya_params {
    DSCBLOCKSIZE = 256,
/*
    RESULTSFORDISPLAY = 20,
*/
    RESULTSFORDISPLAY = 10,
    MAXRESULTSFORDISPLAY = 200,
    MAXWORDSINPHRASE = 16,
    MAXQUERIESINEXPRESSION = 32,
    MAXKEYLENGTH = 64,
    MINKEYLENGTH = 1,
    MAXQUERYLENGTH = (64 * 32),
    MAXSOURCELINELENGTH = (2 * LINE_MAX),
    MAXSORTRESULTS = 16384,
    MAXLEXLOCALINDEX = 32,
    MINCAPITALCOL = 1,
    MINBUFFERINGWORDS = (1024 * 64),
#ifdef ODIN
    MAXBUFFERINGWORDS = (1024 * 128)
#else
/*
    MAXBUFFERINGWORDS = (1024 * 64) // EDIT HERE IF YOU WANT
*/
    MAXBUFFERINGWORDS = (1024 * 1024 * 1)
#endif
};

#endif // CONFIG_H_INCLUDED
