// Copyright (c) 1997 HARADA Masanori. All rights reserved.
//
// $Id: htmlutil.cc,v 0.14 1998-04-25 21:00:46+09 harada Exp $
//
#include "SX.h"
#include "htmlutil.h"

// TODO: numerical timezone is prefererd (RFC 1123)
const char *
rfc822date(char *buf, size_t bufsiz, time_t &t){
    (void)strftime(buf, bufsiz, "%a, %d %b %Y %H:%M:%S %Z", localtime(&t));
    return buf;
}

const char *
html_entitize(char *buf, const char *src){
    char *dp = buf;
    while(*src){
        switch(*src){
        case '<':  strcpy(dp, "&lt;"); dp += 4; break;
        case '>':  strcpy(dp, "&gt;"); dp += 4; break;
        case '&':  strcpy(dp, "&amp;"); dp += 5; break;
        case '"':  strcpy(dp, "&quot;"); dp += 6; break;
        // case '\'': strcpy(dp, "&apos;"); dp += 6; break;
        default: *dp++ = *src; break;
        }
        src++;
    }
    *dp = '\0';
    return buf;
}

char
x2c(char *what) {
    register char digit;

    what[0] = toupper(what[0]);
    what[1] = toupper(what[1]);
    digit = (what[0] >= 'A' ? ((what[0] & 0xdf) - 'A')+10 : (what[0] - '0'));
    digit *= 16;
    digit += (what[1] >= 'A' ? ((what[1] & 0xdf) - 'A')+10 : (what[1] - '0'));
    return digit;
}

void
unescape_url(char *url) {
    int x, y;

    for(x=0; url[x]; x++)
        if(url[x] == '+') url[x] = ' ';
    for(x=0,y=0; url[y]; ++x,++y) {
        if((url[x] = url[y]) == '%') {
            if(isxdigit(url[y+1]) && isxdigit(url[y+2])){
                url[x] = x2c(&url[y+1]);
                y+=2;
            }
        }
    }
    url[x] = '\0';
}

const char *
c2x(char *dst, char c){
    char digits[] = {'0','1','2','3','4','5','6','7','8','9',
                     'A','B','C','D','E','F'};
    int x = (unsigned char)c;
    *dst++ = '%';
    *dst++ = digits[x / 16];
    *dst++ = digits[x % 16];
    return dst - 3;
}

char *
escape_url(const char *url){
    int x, y;
    char *copy = new char[3 * strlen(url) + 1];
            
    for(x=0,y=0; url[x]; x++,y++){
        if(isalnum((unsigned char)url[x])
/*
           || NULL != strchr(".,/:~-_#%", (unsigned char)url[x])){
*/
           || NULL != strchr(".,/:~-_#%?*@=", (unsigned char)url[x])){
            copy[y] = url[x];
        }else{
            c2x(&copy[y], url[x]);
            y += 2;
        }
    }
    copy[y] = '\0';
    return copy;
}
