// Copyright (c) 1997 HARADA Masanori. All rights reserved.
//
// routines for Japanese string (in *euc-japan* encoding)
//  $Id: jlib.cc,v 0.9 1997-12-27 07:49:19+09 harada Exp $
//
#include "SX.h"
#include "jlib.h"

/*
int jstrcmp(const char *s1, const char *s2)
{
    int i = 0;
    int len1 = strlen(s1);
    int len2 = strlen(s2);

    while (len1 > i && len2 > i) {
        unsigned char c = s1[i];
        unsigned char s = s2[i];
        if (c-s != 0) {
            return c-s;
        }
        i++;
    }
    if (len1 < len2) return -1;
    else if (len1 == len2) return 0;
    else return 1;
}
*/
int jstrcmp(const char *s1, const char *s2)
{
    while (1) {
        unsigned char c = *s1++;
        unsigned char s = *s2++;
        unsigned int d = c-s;
        if (d != 0 || c == 0 || s == 0)
            return d;
    }
}

// replace keyword("$foo") as str
int
replace_string(char *buf, const char *keyword, const char *str){
    int replaced = 0;
    int keyLen = -1;
    int strLen = -1;
    char *cp = buf;
    while((cp = strstr(cp, keyword))){
        if( keyLen < 0 ){
            keyLen = strlen(keyword);
            strLen = strlen(str);
        }
        memmove(cp + strLen, cp + keyLen,
                strlen(buf) - (cp + keyLen - buf) + 1);
        strncpy(cp, str, strLen);
        cp += strLen;
        replaced++;
    }
    return replaced;
}


int jstrncmp(const char *s1, const char *s2, int length)
{
    int i = 0;
    int len1 = strlen(s1);
    int len2 = strlen(s2);

    while (len1 > i && len2 > i && i<length) {
        unsigned char c = s1[i];
        unsigned char s = s2[i];
        if (c - s != 0) {
            return c - s;
        }
        i++;
    }

    if ( i == length ) return 0;
    
    if (len1 < len2) return -1;
    else if (len1 == len2) return 0;
    else return 1;
}

// psprefixǤ뤫ɤå
// prefixʤ0֤
// ǤʤСstrcmp()羮ط狼褦֤ͤ
int isprefix(const char *p, const char *s){
    unsigned char *up = (unsigned char *)p;
    unsigned char *us = (unsigned char *)s;
    
    while(*up && *up == *us){
        up += 1; us += 1;
    }
    if(*up == '\0') return 0;
    if(*up > *us) return 1; else return -1;
}

// psprefixǤ뤫ɤåܸEUC(Ȥߤʤ)
// prefixʤ0֤
// ǤʤСstrcmp()羮ط狼褦֤ͤ
int jisprefix(const char *p, const char *s){
    unsigned char *up = (unsigned char *)p;
    unsigned char *us = (unsigned char *)s;
    
    while(*up && *(up + 1) && *us &&
          *up == *us && *(up + 1) == *(us + 1)){
        up += 2; us += 2;
    }
    if(*up == '\0') return 0;
    if(*up == *us){ up++; us++; };
    if(*up > *us) return 1; else return -1;
}

// prefixΰĹ֤
int prefixmatch(const char *s1, const char *s2){
    int p = 0;
    while(*s1 && *s1++ == *s2++) p++;
    return p;
}

// prefixΰĹ֤
// ܸEUC
int jprefixmatch(const char *s1, const char *s2){
    int p = 0;
    while(*s1 && *s1++ == *s2++) p++;
    if(p % 2 != 0) p--;
    return p;
}
