// Copyright (c) 1997 HARADA Masanori. All rights reserved.
//
// $Id: settemplate.h,v 0.9 1997-12-27 07:51:58+09 harada Exp $
//
#ifndef SETTEMPLATE_H_INCLUDED
#define SETTEMPLATE_H_INCLUDED

template <class T>
int multiplyList(T *z, const T *x, int xn, const T *y, int yn);

template <class T>
int multiplyList(T *z, const T *x, int xn, const T *y, int yn, int diff);

template <class T>
int subtractList(T *z, const T *x, int xn, const T *y, int yn);

template <class T>
int mergeList(T *z, const T *x, int xn, const T *y, int yn);

// ------------------------------------------------------------

template <class T>
int multiplyList(T *z, const T *x, int xn, const T *y, int yn){
    int zn;
    int i, j;
    zn = i = j = 0;
    while(i < xn && j < yn){
        if(x[i] < y[j]) i++;
        else if(x[i] > y[j]) j++;
        else{ z[zn] = x[i]; zn++; i++; j++; }
    }
    return zn;
}

template <class T>
int multiplyList(T *z, const T *x, int xn, const T *y, int yn, int diff){
    if(diff == 0) return multiplyList(z, x, xn, y, yn);

    int zn;
    int i, j;
    zn = i = j = 0;
    while(i < xn && j < yn){
        if(x[i] + diff < y[j]) i++;
        else if(x[i] + diff > y[j]) j++;
        else{ z[zn] = x[i]; zn++; i++; j++; }
    }
    return zn;
}

template <class T>
int subtractList(T *z, const T *x, int xn, const T *y, int yn){
    int zn;
    int i, j;
    zn = i = j = 0;
    while(i < xn && j < yn){
        if(x[i] < y[j]) z[zn++] = x[i++];
        else if(x[i] > y[j]) j++;
        else{ i++; j++; }
    }
    while(i < xn)
        z[zn++] = x[i++];
    return zn;
}

template <class T>
int mergeList(T *z, const T *x, int xn, const T *y, int yn){
    int zn;
    int i, j;
    zn = i = j = 0;

    for(;;){
//        cout << "compare: " << x[i] << " and " << y[j] << endl;
        if(i >= xn){
            while(j < yn) z[zn++] = y[j++]; break;
        }
        if(j >= yn){
            while(i < xn) z[zn++] = x[i++]; break;
        }
        if(x[i] < y[j])     { z[zn++] = x[i++]; }
        else if(x[i] > y[j]){ z[zn++] = y[j++]; }
/*
        else{ z[zn] = x[i]; zn++; i++; j++; }
*/
        else{
/*
            fprintf(stderr,"[%d %d %d] %08X %08X DUP\n",
                zn,i,j,(int)(x[i]>>32),(int)x[i]);
*/
            z[zn] = x[i]; zn++; i++; j++;
        }
    }
    return zn;
}

#endif
